'use strict';

var core = require('@git-diff-view/core');
var diff = require('diff');

core._cacheMap.name = "@git-diff-view/file";
function generateDiffFile(oldFileName, oldFileContent, newFileName, newFileContent, oldFileLang, newFileLang, option, uuid) {
    const diffString = diff.createTwoFilesPatch(oldFileName, newFileName, oldFileContent, newFileContent, "", "", option);
    return new core.DiffFile(oldFileName, oldFileContent, newFileName, newFileContent, [diffString], oldFileLang, newFileLang, uuid);
}

exports.generateDiffFile = generateDiffFile;
Object.keys(core).forEach(function (k) {
    if (k !== 'default' && !Object.prototype.hasOwnProperty.call(exports, k)) Object.defineProperty(exports, k, {
        enumerable: true,
        get: function () { return core[k]; }
    });
});
//# sourceMappingURL=index.development.js.map
